#!/usr/bin/python
# -*- coding: utf-8 -*-

"""Promt the user with a y/n/q/? type question.
    
If the user presses 'Q' for quit, a function cleanup() is called 
if provided (to close files, db, etc).
"""

__author__ = "Sven Utcke <sven.utcke@svenutcke.de"
__source__ = "http://www.svenutcke.de/sw/f-spot/cleanup/>"
__version__ = "$Revision: 1.1 $"
__license__ = """Copyright (C) 2011 Sven Utcke <sven.utcke@svenutcke.de>.

A nonexclusive license is granted to use this file for private
purposes.  A seperate license is required for comercial use, the
creation of copies or derivative work.

There is NO WARRANTY, to the extent permitted by law.
"""

import sys
import textwrap
import re

def ckyorn( prompt, helptext="", cleanup=None ):
    """Promt the user with a y/n/q/? type question.
    
    If the user presses 'Q' for quit, a function cleanup() is called 
    if provided (to close files, db, etc).
    """
    ok = 0
    while not ok:
        try:
            a = raw_input( prompt + " [y,n,q,?]: " )
        except EOFError:
            sys.exit(0)
        if a.upper() in [ 'Y', 'N', 'YES', 'NO' ]:
            ok = 1
        if a.upper() in [ 'Q', 'QUIT' ]:
            if cleanup:
                cleanup()
            sys.exit(0)
        if a.upper() in [ '?' ]:
            for par in helptext.split('\n\n'):
                # somehos textwrap.dedent() does not work for me?
                print '\n', textwrap.fill(re.sub('^[ \t]*', '', re.sub('[ \t][ \t]*', ' ', par)))
    return a.upper()[0] 
