#!/usr/bin/python
# -*- coding: utf-8 -*-

"""Convenience functions to deal with uri-encoded material.

Usually, all things to to with uri-encoding will be handled by urllib.
Unfortunately, some versions of f-spot produce only partly url-encoded
strings, and this urllib does not know how to deal with.  Hence this
file...
"""

__author__ = "Sven Utcke <sven.utcke@svenutcke.de"
__source__ = "http://www.svenutcke.de/sw/f-spot/cleanup/>"
__version__ = "$Revision: 1.1 $"
__license__ = """Copyright (C) 2011 Sven Utcke <sven.utcke@svenutcke.de>.

A nonexclusive license is granted to use this file for private
purposes.  A seperate license is required for comercial use, the
creation of copies or derivative work.

There is NO WARRANTY, to the extent permitted by law.
"""

def dec2hex(n):
    """return the hexadecimal string representation of integer n"""
    return "%X" % n
 
def hex2dec(s):
    """return the integer value of a hexadecimal string s"""
    return int(s, 16)

def unquote(uri, encoding='utf-8'):
    """Unquote all uri-encoded characters back to normal.

    Note: this will call uri.decode(encoding) on the input string"""
    uri = uri.encode(encoding)
    ret = ''
    i = 0
    while i < len(uri):
        if uri[i] == '%' \
                and uri[i+1].lower() in '1234567890abcdef' \
                and uri[i+2].lower() in '1234567890abcdef':
            ret += chr(hex2dec(uri[i+1:i+3]))
            i += 2
        else:
            ret += uri[i]
        i += 1
    return ret
